/*
   Copyright  Silviu-Marius ARDELEAN  2008
        http://silviuonline.8k.ro

   This code is provided AS-IS.
   You can use this code in any application (free or commercial) as long as you keep this notice.
*/

#pragma once
#include <map>
#include <vector>

struct ItemsData
{
	int				nID;
	int				nParentID;
	bool			bHasChilds;
	bool			bIsVisible;
	bool			bCheckFlag;
	bool			bEnableFlag;
	bool			bIsSeparator;
	std::wstring	sItemName;	

	ItemsData(const int& id = 0, int parentid = 0, bool is_visible = false, bool bchild = false, bool check_flag = false, 
				bool enable_flag = false, bool is_separator = false, const std::wstring& itemname = _T("")) :
		nID(id)
		, nParentID(parentid)
		, bHasChilds(bchild)
		, bCheckFlag(check_flag)
		, bEnableFlag(enable_flag)
		, bIsVisible(is_visible)
		, bIsSeparator(is_separator)
		, sItemName(itemname)
	 {}

};

typedef std::map<int, ItemsData>				DynamicMenuData;
typedef std::map<int, ItemsData>::iterator		iterDynMenu;

class CDynamicPopupMenu
{
public:
	CDynamicPopupMenu(void) {}
	~CDynamicPopupMenu(void);

	void	AddItemData(const int item_id, const int parent_id, bool is_visible, bool check_flag, bool has_child,  
										const std::wstring item_name, bool enable_flag);
	void	AddItemSeparator(const int item_id, const int parent_id);

	DynamicMenuData* GetDynamicMenuData()  { return &m_menuMap; } 
	void	ResetMenuInternalData() { m_menuMap.clear(); }

	DWORD	TrackPopupCustomMenu(POINT point, HWND hWnd);

	void	SelectShowAllGroupItems(const int nKeyShowAll, bool bIsVisible);
	void	CheckAllGroupItems(const int nKeyCheckAll, bool bChecked);

	bool	SetCheckedItemFlag(const int nMapKey, const bool bFlag);
	bool	GetItemCheckedFlag(const int nMapKey, bool& bFlag);

	bool	SetEnableFlagItem(const int nMapKey, bool bFlag);
	bool	GetEnableFlagItem(const int nMapKey, bool& bFlag);

	bool	SetVisibleFlagItem(const int nMapKey, bool bFlag);
	bool	GetVisibleFlagItem(const int nMapKey, bool& bFlag);

	bool	GetIsVisible(iterDynMenu it) const	{ return (*it).second.bIsVisible; }
	bool	GetIsChecked(iterDynMenu it) const	{ return (*it).second.bCheckFlag; }
	bool	GetIsEnable(iterDynMenu it) const	{ return (*it).second.bEnableFlag; }
		

private:
	DynamicMenuData		m_menuMap;
};

